#define SERIESRESISTOR 10000
#define NOMINAL_RESISTANCE 10000
#define VALIM 5
#define NOMINAL_TEMPERATURE 25
#define BCOEFFICIENT 3950

// acquisition sonde collier 1
void ANA_Get_Teta1 () {

  static int tableau[5];
  static byte index = 0;
  float steinhart;
  float u, i, r;

  // moyennage tesion
  tableau[index] = analogRead(pinTeta1);
  if (++index > 4) index = 0;
  u = (tableau[0] + tableau[1] + tableau[2] + tableau[3] + tableau[4]) / 5;

  //conversion de la tension en resistance
  u = (u * 3.3) / 1024;
  i = u / SERIESRESISTOR;
  r = (VALIM - u) / i;

  // equation de steinhart pour converson en temperature
  steinhart = r / NOMINAL_RESISTANCE; // (R/Ro)
  steinhart = log(steinhart); // ln(R/Ro)
  steinhart /= BCOEFFICIENT; // 1/B * ln(R/Ro)
  steinhart += 1.0 / (NOMINAL_TEMPERATURE + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart; // Invert
  steinhart -= 273.15; // convert to C
  teta1 = (steinhart * 10) + sauv.calib1;
}


// acquisition sonde collier 2
void ANA_Get_Teta2() {
  
  static int tableau[5];
  static byte index = 0;
  float steinhart;
  float u, i, r;

  // moyennage tesion
  tableau[index] = analogRead(pinTeta2);
  if (++index > 4) index = 0;
  u = (tableau[0] + tableau[1] + tableau[2] + tableau[3] + tableau[4]) / 5;

  //conversion de la tension en resistance
  u = (u * 3.3) / 1024;
  i = u / SERIESRESISTOR;
  r = (VALIM - u) / i;

  // equation de steinhart pour converson en temperature
  steinhart = r / NOMINAL_RESISTANCE; // (R/Ro)
  steinhart = log(steinhart); // ln(R/Ro)
  steinhart /= BCOEFFICIENT; // 1/B * ln(R/Ro)
  steinhart += 1.0 / (NOMINAL_TEMPERATURE + 273.15); // + (1/To)
  steinhart = 1.0 / steinhart; // Invert
  steinhart -= 273.15; // convert to C
  teta2 = (steinhart * 10) + sauv.calib2;
}


// acquisition tension batterie
void ANA_Get_Vbat() {

  static int tableau[5];
  static byte index = 0;
  float moy;

  // moyennage tesion
  tableau[index] = analogRead(pinVbat);
  if (++index > 4) index = 0;
  moy = (tableau[0] + tableau[1] + tableau[2] + tableau[3] + tableau[4]) / 5;
  moy = (moy * 15.522222) / 1024;
  tension_batterie = moy * 10;
}



