/*
  configure le module bluetooth avec nouveau paramÃƒÂ¨tre nom et mot de passe
*/
void BLUE_ChangeConfig () {
  char c1, c2;
  int time_out;

  wdt_reset();

  //Envoi command AT et attente de rÃƒÂ©ponse du module
  while (1) {

    BLUE_SerialFlush();
    Serial.println("\r\nBluetooth AT send :");
    btSerial.print("AT\r\n");

    time_out = millis() + 3000;
    while (1) {
      wdt_reset();
      if (btSerial.available() > 1) break;
      if (millis() > time_out) break;
    }
    if (btSerial.available() > 1) {
      c1 = btSerial.read() ;
      c2 = btSerial.read() ;
      if ((c1 == 'O') && (c2 == 'K')) {
        Serial.println("OK");
        break;
      }
    } else {
      Serial.println("Bad Response");
    }
  }

  delay(1000);

  while (1) {
    BLUE_SerialFlush();
    Serial.println("\r\nSend new name:");
    btSerial.print("AT+NAME=");
    btSerial.print(nom_module);
    btSerial.print("\r\n");
    time_out = millis() + 3000;
    while (1) {
      wdt_reset();
      if (btSerial.available() > 1) break;
      if (millis() > time_out) break;
    }

    if (btSerial.available() > 1) {
      c1 = btSerial.read() ;
      c2 = btSerial.read() ;
      if ((c1 == 'O') && (c2 == 'K')) {
        Serial.println("OK");
        break;
      }
    } else {
      Serial.println("Bad Reponse");
    }
  }

  delay(1000);

  while (1) {
    BLUE_SerialFlush();
    Serial.println("\r\nSend new Pin Code:");
    btSerial.print("AT+PSWD=");
    btSerial.write(0x22);
    btSerial.print(code_module);
    btSerial.write(0x22);
    btSerial.print("\r\n");

    time_out = millis() + 3000;
    while (1) {
      wdt_reset();
      if (btSerial.available() > 1) break;
      if (millis() > time_out) break;
    }
    if (btSerial.available() > 1) {
      c1 = btSerial.read() ;
      c2 = btSerial.read() ;
      if ((c1 == 'O') && (c2 == 'K')) {
        Serial.println("OK");
        break;
      }
    } else {
      Serial.println("Bad Reponse");
    }
  }

  Serial.print("\r\nPlease reboot module");
  delay(100);

  while (1) {
    digitalWrite(LED_BUILTIN, HIGH);   // allume la led
    delay(50);
    digitalWrite(LED_BUILTIN, LOW);    // eteind la led
    delay(50);
  }
}

void BLUE_Process_Buffer () {
  static char bufferbt[LEN_BUFFER];   // buffer de reception Bluetooth
  static unsigned int index = 0;      // index du buffer ene ecriture
  static byte trame_start = 0;        // dÃƒÂ©but de trame dÃƒÂ©tectÃƒÂ© (@)

  int count;
  int i;

  byte cursor_stop = 0xff;
  byte compare = 0;
  wdt_reset();
  if (btSerial.available() == 0) return;

  if (trame_start == 0) {
    while (btSerial.available() != 0) {
      if (btSerial.read() == '@') {
        trame_start = 1;
        break;
      }
    }
  }

  if (trame_start == 0) return;

  count = btSerial.available();

  // remplissage buffer reception
  for (i = 0; i < count; i++) {
    bufferbt[index++] = btSerial.read();

    // si dÃƒÂ©bordement on efface tout
    if (index > LEN_BUFFER - 1) {
      index = 0;
      trame_start = 0;
      BLUE_FormatBuffer(bufferbt);
      return;
    }
  }

  // cherche premiere occurance de CRLF
  for (i = 0; i < LEN_BUFFER; i++) {
    if ((bufferbt[i] == '\r') && (bufferbt[i + 1] == '\n')) {
      cursor_stop = i ;

      break;
    }
  }

  // arrete le traitement si aucun critere ne correspond
  if (cursor_stop == 0xff) return;

  // pour debug Serial.println(bufferbt);
 
  // commande RDATAT ?
  if ( strstr (bufferbt , "RDATAT") != 0) {
    btSerial.print("@OKATAT\r");
    index = 0;
    trame_start = 0;
    BLUE_FormatBuffer(bufferbt);
    return;
  }
  if ( strstr (bufferbt , "RDVARI") != 0) {
    BLUE_ProcessRDVARI();
    index = 0;
    trame_start = 0;
    BLUE_FormatBuffer(bufferbt);
    return;
  }

  if ( strstr (bufferbt , "RDPEPP") != 0) {
    BLUE_ProcessRDPEPP();
    index = 0;
    trame_start = 0;
    BLUE_FormatBuffer(bufferbt);
    return;
  }

  if ( strstr (bufferbt , "WRPEPP") != 0) {
    if (BLUE_ProcessWRPEPP(bufferbt + 6) == true) {
      btSerial.print("@OKPEPP\r");
    }
    else {
      btSerial.print("@NOPEPP\r");
    }
    index = 0;
    trame_start = 0;
    BLUE_FormatBuffer(bufferbt);
    return;
  }

  if ( strstr (bufferbt , "WRSTDP") != 0) {
    if (BLUE_ProcessWRSTDP(bufferbt + 6) == true) {
      btSerial.print("@OKSTDP\r");
    }
    else {
      btSerial.print("@NOSTDP\r");
    }
    index = 0;
    trame_start = 0;
    BLUE_FormatBuffer(bufferbt);
    return;
  }



}

/*
  execute l'ordre RDREPP
*/
void BLUE_ProcessRDPEPP () {

  byte sauv_mode1, sauv_mode2, sauv_cons_pwm_manu1, sauv_cons_pwm_manu2;

  // sauvegarde des paramÃƒÂ¨tres mode manuel afin de ne pas changer les valeurs en cours

  sauv_mode1 = sauv.mode1;
  sauv_mode2 = sauv.mode2;
  sauv_cons_pwm_manu1 = sauv.cons_pwm_manu1;
  sauv_cons_pwm_manu2 = sauv.cons_pwm_manu2;

  if (EPP_Read() == false) {
    btSerial.print("@NOPEPP");
    return;
  }

  btSerial.print("@OKPEPP");
  btSerial.print(sauv.mode1);
  btSerial.print("|");
  btSerial.print(sauv.mode2);
  btSerial.print("|");
  btSerial.print(sauv.cons_pwm_manu1);
  btSerial.print("|");
  btSerial.print(sauv.cons_pwm_manu2);
  btSerial.print("|");
  btSerial.print(sauv.cons_max_pwm_v1);
  btSerial.print("|");
  btSerial.print(sauv.cons_max_pwm_v2);
  btSerial.print("|");
  btSerial.print(sauv.cons_delta_m1_v1);
  btSerial.print("|");
  btSerial.print(sauv.cons_delta_m1_v2);
  btSerial.print("|");
  btSerial.print(sauv.cons_delta_m2_v1);
  btSerial.print("|");
  btSerial.print(sauv.cons_delta_m2_v2);
  btSerial.print("|");
  btSerial.print(sauv.calib1, DEC);
  btSerial.print("|");
  btSerial.print(sauv.calib2, DEC);
  btSerial.print("|");
  btSerial.print("\r");

  // restitue les donnÃƒÂ©es
  sauv.mode1 = sauv_mode1;
  sauv.mode2 = sauv_mode2;
  sauv.cons_pwm_manu1 = sauv_cons_pwm_manu1;
  sauv.cons_pwm_manu2 = sauv_cons_pwm_manu2;

}


/*
  execute l'ordre RDVARI
*/
void BLUE_ProcessRDVARI() {

  btSerial.print("@OKVARI");
  btSerial.print(teta_ext);
  btSerial.print("|");
  btSerial.print(hygro_ext);
  btSerial.print("|");
  btSerial.print(pts_rosee);
  btSerial.print("|");
  btSerial.print(teta1);
  btSerial.print("|");
  btSerial.print(teta2);
  btSerial.print("|");
  btSerial.print(tension_batterie);
  btSerial.print("|");
  btSerial.print(out_pwm1);
  btSerial.print("|");
  btSerial.print(out_pwm2);
  btSerial.print("|");
  btSerial.print(sauv.mode1);
  btSerial.print("|");
  btSerial.print(sauv.mode2);
  btSerial.print("|");
  btSerial.print("\r");
}


/*
  execute l'ordre WRSTDP
*/
bool BLUE_ProcessWRSTDP (char *buffer) {
  byte value;
  byte stop;
  char str[5];


  // extraction de la valeur de mode manu 1

  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 2)) {
    sauv.mode1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction de la valeur de mode manu 2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 2)) {
    sauv.mode2 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction de la valeur pwm1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_pwm_manu1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction de la valeur pwm2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_pwm_manu2 = value;
  } else {
    return false;
  }

  return true;
}


/*
  execute l'ordre WRPEPP
*/
bool BLUE_ProcessWRPEPP (char *buffer) {
  byte value;
  byte stop;
  char str[5];
  int i;
  byte sauv_mode1, sauv_mode2, sauv_cons_pwm_manu1, sauv_cons_pwm_manu2;

  // sauvegarde des paramÃƒÂ¨tres mode manuel afin de ne pas changer les valeurs en cours

  sauv_mode1 = sauv.mode1;
  sauv_mode2 = sauv.mode2;
  sauv_cons_pwm_manu1 = sauv.cons_pwm_manu1;
  sauv_cons_pwm_manu2 = sauv.cons_pwm_manu2;


  // extraction de la valeur de mode manu 1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 2)) {
    sauv.mode1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction de la valeur de mode manu 2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 2)) {
    sauv.mode2 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;


  // extraction de la valeur pwm1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_pwm_manu1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;


  // extraction de la valeur pwm2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_pwm_manu2 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction de la valeur maximum pwm1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_max_pwm_v1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;


  // extraction de la valeur maximum pwm2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_max_pwm_v2 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;


  // extraction valeur debut de chauffe voie1 mode 1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_delta_m1_v1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction valeur debut de chauffe voie2 mode 1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 100)) {
    sauv.cons_delta_m1_v2 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;


  // extraction valeur consigne collier voie1 mode 2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 151)) {
    sauv.cons_delta_m2_v1 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction valeur consigne collier voie2 mode 2
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  value = atoi(str);
  if ((value >= 0) && (value <= 151)) {
    sauv.cons_delta_m2_v2 = value;
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction valeur calibration sonde temperature 1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  i = atoi(str);

  if ((i >= (-50)) && (i <= 50)) {
    sauv.calib1 = (char)(i);
  } else {
    return false;
  }
  buffer = buffer + stop + 1 ;

  // extraction valeur calibration sonde temperature 1
  stop = 0;
  while (1) {
    if (buffer[stop] == '|') break;
    if (stop++ > 3) return false;
  }
  memcpy(str, buffer, stop);
  str[stop] = 0;
  i = atoi(str);
  if ((i >= (-50)) && (i <= 50)) {
    sauv.calib2 = (char)(i);
  } else {
    return false;
  }



  // sauvegarde en EEprom
  EPP_Write();

  // restitue les donnÃƒÂ©es
  sauv.mode1 = sauv_mode1;
  sauv.mode2 = sauv_mode2;
  sauv.cons_pwm_manu1 = sauv_cons_pwm_manu1;
  sauv.cons_pwm_manu2 = sauv_cons_pwm_manu2;
  return true;
}


/*
  format le buffer de travail bluetooth
*/
void BLUE_FormatBuffer (char *buffer) {
  byte i;

  for (i = 0; i < LEN_BUFFER; i++) {
    buffer[i] = 0;
  }
}

/*
  vide le buffer de reception
*/
void BLUE_SerialFlush() {
  char c;
  while (btSerial.available() > 0) {
    c = btSerial.read();
  }
}


