

boolean EPP_Read() {

  unsigned int result_crc;              // rÃƒÂ©sultat du crc
  int size_struct = sizeof(sauv);       // taille de la structure ÃƒÂ  sauvegarder
  char buffer[size_struct];             // buffer de conversion
  unsigned int i;

  // lecture des donnÃƒÂ©es en EEPROM
  for (i = 0; i < size_struct; i++) {
    buffer[i] = EEPROM.read(i);
  }

  // calcul du crc
  result_crc = crc16(buffer, size_struct - 2);

  // comparaison pour vÃƒÂ©rification
  if (buffer[size_struct - 2] != (char)(result_crc >> 8) )return false  ;
  if (buffer[size_struct - 1] != (char)(result_crc) )return false  ;

  // si crc ok on remplie la structure
  memcpy(&sauv, buffer, size_struct);
  return true;
}


void EPP_Write () {
  unsigned short result_crc;              // rÃƒÂ©sultat du crc
  int size_struct = sizeof(sauv);       // taille de la structure ÃƒÂ  sauvegarder
  char buffer[size_struct];             // buffer de conversion
  unsigned int i;

  // copie de vglobal dans le buffer
  memcpy(buffer, &sauv, size_struct);

  //calcul crc et inscription ÃƒÂ  la fin du buffer
  result_crc = crc16(buffer, size_struct - 2);

  buffer[size_struct - 2] = (char) (result_crc >> 8);
  buffer[size_struct - 1] = (char)(result_crc);

  //enregistrement EEPROM
  for (i = 0; i < size_struct; i++) {
    EEPROM.write(i, buffer[i]);
  }
  delay(50);
}

// paramÃƒÂ©trage par des valeurs sauvegardÃƒÂ©es par defaut
void EPP_SetDefault () {
  sauv.mode1 = MODE_MANU;         // mode de fonctionnement voie 1
  sauv.mode2 = MODE_MANU;         // mode de fonctionnement voie 2
  sauv.cons_pwm_manu1 = 20;       // consigne pwm mode manuel voie 1
  sauv.cons_pwm_manu2 = 20;       // consigne pwm mode manuel voie 2
  sauv.cons_max_pwm_v1 = 70;   // consigne maximum pwm mode 1 voie 1
  sauv.cons_max_pwm_v2 = 70;   // consigne maximum pwm mode 1 voie 2
  sauv.cons_delta_m1_v1 = 70;     // consigne delta dÃƒÂ©but enclenchement chauffe par rapport au point de rosÃƒÂ©, voie 1
  sauv.cons_delta_m1_v2 = 70;     // consigne delta dÃƒÂ©but enclenchement chauffe par rapport au point de rosÃƒÂ©, voie 2
  sauv.cons_delta_m2_v1 = 50;     // consigne tempÃƒÂ©rature collier, voie 1
  sauv.cons_delta_m2_v2 = 50;     // consigne tempÃƒÂ©rature collier, voie 2
  sauv.calib1 = 0;                // calibration sonde collier voie 1
  sauv.calib2 = 0;                // calibration sonde collier voie 2
  EPP_Write();

}

// crc16
unsigned short crc16(const unsigned char* data_p, unsigned char length){
    unsigned char x;
    unsigned short crc = 0xFFFF;
     
    while (length--){
        x = crc >> 8 ^ *data_p++;
        x ^= x>>4;
        crc = (crc << 8) ^ ((unsigned short)(x << 12)) ^ ((unsigned short)(x <<5)) ^ ((unsigned short)x);
    }
    return crc;
}



